<?php

namespace Drupal\grant\Plugin\views\argument_default;

use Drupal\Core\Cache\Cache;
use Drupal\Core\Cache\CacheableDependencyInterface;
use Drupal\views\Plugin\views\argument_default\ArgumentDefaultPluginBase;

/**
 * GrantCurrentUserMail argument default plugin.
 *
 * @ViewsArgumentDefault(
 *   id = "grant_current_user_emails",
 *   title = @Translation("User email address(es) from logged in user (grant module)")
 * )
 */
class GrantCurrentUserEmails extends ArgumentDefaultPluginBase implements CacheableDependencyInterface {

  /**
   * {@inheritdoc}
   */
  public function getArgument() {
    // Because of https://www.drupal.org/project/drupal/issues/3301388
    // we alter the query for multiple mails in grant.views_execution.inc.
    return \Drupal::currentUser()->getEmail();
  }

  /**
   * {@inheritdoc}
   */
  public function getCacheMaxAge() {
    return Cache::PERMANENT;
  }

  /**
   * {@inheritdoc}
   */
  public function getCacheContexts() {
    return ['user'];
  }

}
