<?php

namespace Drupal\grant\Plugin\views\argument_default;

use Drupal\Core\Cache\Cache;
use Drupal\Core\Cache\CacheableDependencyInterface;
use Drupal\views\Plugin\views\argument_default\ArgumentDefaultPluginBase;
use Drupal\user\Entity\User;

/**
 * GrantCurrentUserUuid argument default plugin.
 *
 * @ViewsArgumentDefault(
 *   id = "grant_current_user_uuid",
 *   title = @Translation("User UUID from logged in user (grant module)")
 * )
 */
class GrantCurrentUserUuid extends ArgumentDefaultPluginBase implements CacheableDependencyInterface {

  /**
   * {@inheritdoc}
   */
  public function getArgument() {
    return User::load(\Drupal::currentUser()->id())->uuid();
  }

  /**
   * {@inheritdoc}
   */
  public function getCacheMaxAge() {
    return Cache::PERMANENT;
  }

  /**
   * {@inheritdoc}
   */
  public function getCacheContexts() {
    return ['user'];
  }

}
